BITS 32
GLOBAL _msethlineshift
GLOBAL _tsethlineshift
GLOBAL _mhline
GLOBAL _thline
GLOBAL _vlineasm1
GLOBAL _vlineasm4
GLOBAL _prevlineasm1
GLOBAL _sethlinesizes
GLOBAL _hlineasm4
GLOBAL _setuphlineasm4
GLOBAL _setupvlineasm
GLOBAL _setpalookupaddress
GLOBAL _setvlinebpl
GLOBAL _detectmmx
GLOBAL _fixtransluscence
EXTERN _asm1;
EXTERN _asm2;
EXTERN _asm3;
EXTERN _asm4;
EXTERN _ylookup;
EXTERN _bufplce;
EXTERN _palookupoffse;
EXTERN _vince;
EXTERN _vplce;

;Uncomment stuff in _setvlinebpl as soon as we add more functions
;Uncomment stuff in _fixtranslucence

SECTION .data ALIGN = 16;

ALIGN 16
_setupvlineasm:
		;First 2 lines for VLINEASM1, rest for VLINEASM4
	push ebp;
	mov ebp, esp;
	add ebp, 8;
	mov eax, [ebp - 0];

	mov [premach3a+2], al
	mov [mach3a+2], al

	push ecx
	mov [machvsh1+2], al      ;32-shy
	mov [machvsh3+2], al      ;32-shy
	mov [machvsh5+2], al      ;32-shy
	mov [machvsh6+2], al      ;32-shy
	mov ah, al
	sub ah, 16
	mov [machvsh8+2], ah      ;16-shy
	neg al
	mov [machvsh7+2], al      ;shy
	mov [machvsh9+2], al      ;shy
	mov [machvsh10+2], al     ;shy
	mov [machvsh11+2], al     ;shy
	mov [machvsh12+2], al     ;shy
	mov cl, al
	mov eax, 1
	shl eax, cl
	dec eax
	mov [machvsh2+2], eax    ;(1<<shy)-1
	mov [machvsh4+2], eax    ;(1<<shy)-1
	pop ecx
	pop ebp
	ret

ALIGN 16
_prevlineasm1:

	push ebp;
	mov ebp, esp;
	add ebp, 28;
	mov eax, [ebp - 20];
	mov ebx, [ebp - 16];
	mov ecx, [ebp - 12];
	mov edx, [ebp - 8];
	mov esi, [ebp - 4];
	mov edi, [ebp - 0];

	test ecx, ecx
	jnz _vlineasm1jmp

	add eax, edx
premach3a: 
	shr edx, 32
	mov dl, [esi+edx]
	mov cl, [ebx+edx]
	mov [edi], cl
	pop ebp
	ret

ALIGN 16
_vlineasm1:
	push ebp;
	mov ebp, esp;
	add ebp, 28;
	mov eax, [ebp - 20];
	mov ebx, [ebp - 16];
	mov ecx, [ebp - 12];
	mov edx, [ebp - 8];
	mov esi, [ebp - 4];
	mov edi, [ebp - 0];
_vlineasm1jmp:
	mov ebp, ebx
	inc ecx
fixchain1a: 
	sub edi, 320
beginvline:
	mov ebx, edx
mach3a: 
	shr ebx, 32
fixchain1b: 
	add edi, 320
	mov bl, [esi+ebx]
	add edx, eax
	dec ecx
	mov bl, [ebp+ebx]
	mov [edi], bl
	jnz short beginvline
	pop ebp
	mov eax, edx
	ret

ALIGN 16
_vlineasm4:
	push ebp
	mov ebp, esp;
	add ebp, 12;
	mov ecx, [ebp - 4];
	mov edi, [ebp - 0];
	
	mov eax, [_ylookup + ecx*4]
	add eax, edi
	mov [machvline4end+2], eax
	sub edi, eax

	mov eax, [_bufplce + 0]
	mov ebx, [_bufplce + 4]
	mov ecx, [_bufplce + 8]
	mov edx, [_bufplce + 12]
	mov [machvbuf1+2], ecx
	mov [machvbuf2+2], edx
	mov [machvbuf3+2], eax
	mov [machvbuf4+2], ebx

	mov eax, [_palookupoffse + 0]
	mov ebx, [_palookupoffse + 4]
	mov ecx, [_palookupoffse + 8]
	mov edx, [_palookupoffse + 12]
	mov [machvpal1+2], ecx
	mov [machvpal2+2], edx
	mov [machvpal3+2], eax
	mov [machvpal4+2], ebx

		;     Ŀ
		;edx: v3lo           v1lo           
		;     Ĵ
		;esi: v2hi  v2lo                v3hi
		;     Ĵ
		;ebp: v0hi  v0lo                v1hi
		;     

	mov ebp, [_vince + 0]
	mov ebx, [_vince + 4]
	mov esi, [_vince + 8]
	mov eax, [_vince + 12]
	and esi, 0fffffe00h
	and ebp, 0fffffe00h
machvsh9: rol eax, 88h                 ;sh
machvsh10: rol ebx, 88h                ;sh
	mov edx, eax
	mov ecx, ebx
	shr ecx, 16
	and edx, 0ffff0000h
	add edx, ecx
	and eax, 000001ffh
	and ebx, 000001ffh
	add esi, eax
	add ebp, ebx
	;
	mov eax, edx
	and eax, 0ffff0000h
	mov [machvinc1+2], eax
	mov [machvinc2+2], esi
	mov [machvinc3+2], dl
	mov [machvinc4+2], dh
	mov [machvinc5+2], ebp

	mov ebp, [_vplce + 0]
	mov ebx, [_vplce + 4]
	mov esi, [_vplce + 8]
	mov eax, [_vplce + 12]
	and esi, 0fffffe00h
	and ebp, 0fffffe00h
machvsh11: rol eax, 88h                ;sh
machvsh12: rol ebx, 88h                ;sh
	mov edx, eax
	mov ecx, ebx
	shr ecx, 16
	and edx, 0ffff0000h
	add edx, ecx
	and eax, 000001ffh
	and ebx, 000001ffh
	add esi, eax
	add ebp, ebx

	mov ecx, esi
	jmp short beginvlineasm4
ALIGN 16
	nop
	nop
	nop
beginvlineasm4:
machvsh1: shr ecx, 88h          ;32-sh
	mov ebx, esi
machvsh2: and ebx, 00000088h    ;(1<<sh)-1
machvinc1: add edx, 88880000h
machvinc2: adc esi, 88888088h
machvbuf1: mov cl, [ecx+88888888h]
machvbuf2: mov bl, [ebx+88888888h]
	mov eax, ebp
machvsh3: shr eax, 88h          ;32-sh
machvpal1: mov cl, [ecx+88888888h]
machvpal2: mov ch, [ebx+88888888h]
	mov ebx, ebp
	shl ecx, 16
machvsh4: and ebx, 00000088h    ;(1<<sh)-1
machvinc3: add dl, 88h
machvbuf3: mov al, [eax+88888888h]
machvinc4: adc dh, 88h
machvbuf4: mov bl, [ebx+88888888h]
machvinc5: adc ebp, 88888088h
machvpal3: mov cl, [eax+88888888h]
machvpal4: mov ch, [ebx+88888888h]
machvline4end: mov [edi+88888888h], ecx
fixchain2a: add edi, 88888888h
	mov ecx, esi
	jnc short beginvlineasm4

		;     Ŀ
		;edx: v3lo           v1lo           
		;     Ĵ
		;esi: v2hi  v2lo                v3hi
		;     Ĵ
		;ebp: v0hi  v0lo                v1hi
		;     

	mov [_vplce + 8], esi
	mov [_vplce + 0], ebp
		;vplc2 = (esi<<(32-sh))+(edx>>sh)
		;vplc3 = (ebp<<(32-sh))+((edx&65535)<<(16-sh))
machvsh5: shl esi, 88h     ;32-sh
	mov eax, edx
machvsh6: shl ebp, 88h     ;32-sh
	and edx, 0000ffffh
machvsh7: shr eax, 88h     ;sh
	add esi, eax
machvsh8: shl edx, 88h     ;16-sh
	add ebp, edx
	mov [_vplce + 12], esi
	mov [_vplce + 4], ebp

	pop ebp
	ret

ALIGN 16
_fixtransluscence:
	push ebp;
	mov ebp, esp;
	add ebp, 8;
	mov eax, [ebp - 0];
	;mov [transmach4+2], eax
	mov [tmach1+2], eax
	mov [tmach2+2], eax
	mov [tmach3+2], eax
	;mov [tmach4+2], eax
	;mov [tran2traa+2], eax
	;mov [tran2trab+2], eax
	;mov [tran2trac+2], eax
	;mov [tran2trad+2], eax
	pop ebp;
	ret

ALIGN 16
_tsethlineshift:
	push ebp;
	mov ebp, esp;
	add ebp, 12;
	mov eax, [ebp - 4];
	mov ebx, [ebp - 0];
	neg al
	mov [tsh1d+2], al
	mov [tsh2d+3], bl
	mov [tsh3d+2], al
	mov [tsh4d+3], bl
	mov [tsh5d+2], al
	mov [tsh6d+3], bl
	pop ebp;
	ret

ALIGN 16
_msethlineshift:
	push ebp;
	mov ebp, esp;
	add ebp, 12;
	mov eax, [ebp - 4];
	mov ebx, [ebp - 0];

	neg al
	mov [msh1d+2], al
	mov [msh2d+3], bl
	mov [msh3d+2], al
	mov [msh4d+3], bl
	mov [msh5d+2], al
	mov [msh6d+3], bl
	pop ebp;
	ret

ALIGN 16
_thline:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax = picoffs
	;ebx = bx
	;ecx = cnt
	;edx = ?
	;esi = by
	;edi = p

	push ebp;
	mov ebp, esp;
	add ebp, 28;
	mov eax, [ebp - 20];
	mov ebx, [ebp - 16];
	mov ecx, [ebp - 12];
	mov edx, [ebp - 8];
	mov esi, [ebp - 4];
	mov edi, [ebp - 0];

	mov [tmach1d+2], eax
	mov [tmach5d+2], eax
	mov [tmach9d+2], eax
	mov eax, [_asm3]
	mov [tmach2d+2], eax
	mov [tmach6d+2], eax
	mov [tmach10d+2], eax
	mov eax, [_asm1]
	mov [tmach3d+2], eax
	mov [tmach7d+2], eax
	mov eax, [_asm2]
	mov [tmach4d+2], eax
	mov [tmach8d+2], eax
	pop ebp;
	jmp thlineskipmodify_

ALIGN 16
thlineskipmodify_:

	push ebp

	xor eax, eax
	xor edx, edx
	mov ebp, ebx

	test ecx, 00010000h
	jnz short tbeghline

tsh1d: shr ebx, 26
tsh2d: shld ebx, esi, 6
	add ebp, [_asm1]
tmach9d: mov al, [ebx+88888888h]    ;picoffs
	add esi, [_asm2]
	cmp al, 255
	je tskip5

transrev4:
tmach10d: mov dl, [eax+88888888h]   ;shadeoffs
transrev5:
	mov dh, [edi]
tmach1: mov al, [edx+88888888h]     ;_transluc
	mov [edi], al
tskip5:
	inc edi
	sub ecx, 65536
	jc near tendhline
	jmp short tbeghline

ALIGN 16
tprebeghline:
	add edi, 2
	sub ecx, 131072
	jc short tendhline
tbeghline:
tmach3d: lea ebx, [ebp+88888888h]            ;bxinc
tsh3d: shr ebp, 26
tsh4d: shld ebp, esi, 6
tmach4d: add esi, 88888888h                  ;byinc
tmach1d: mov cl, [ebp+88888888h]    ;picoffs
tmach7d: lea ebp, [ebx+88888888h]            ;bxinc

tsh5d: shr ebx, 26
tsh6d: shld ebx, esi, 6
tmach8d: add esi, 88888888h                  ;byinc
tmach5d: mov ch, [ebx+88888888h]    ;picoffs

	cmp cx, 0ffffh
	je short tprebeghline

	mov bx, [edi]

	cmp cl, 255
	je short tskip1
	mov al, cl
transrev6:
tmach2d: mov dl, [eax+88888888h]    ;shadeoffs
transrev7:
	mov dh, bl
tmach2: mov al, [edx+88888888h]     ;_transluc
	mov [edi], al

	cmp ch, 255
	je short tskip2
tskip1:
	mov al, ch
transrev8:
tmach6d: mov dl, [eax+88888888h]    ;shadeoffs
transrev9:
	mov dh, bh
tmach3: mov al, [edx+88888888h]     ;_transluc
	mov [edi+1], al
tskip2:

	add edi, 2
	sub ecx, 131072
	jnc tbeghline
tendhline:

	pop ebp
	ret

ALIGN 16
_mhline:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax = picoffs
	;ebx = bx
	;ecx = cnt
	;edx = ?
	;esi = by
	;edi = p

	push ebp;
	mov ebp, esp;
	add ebp, 28;
	mov eax, [ebp - 20];
	mov ebx, [ebp - 16];
	mov ecx, [ebp - 12];
	mov edx, [ebp - 8];
	mov esi, [ebp - 4];
	mov edi, [ebp - 0];

	mov [mmach1d+2], eax
	mov [mmach5d+2], eax
	mov [mmach9d+2], eax
	mov eax, [_asm3]
	mov [mmach2d+2], eax
	mov [mmach2da+2], eax
	mov [mmach2db+2], eax
	mov [mmach6d+2], eax
	mov [mmach10d+2], eax
	mov eax, [_asm1]
	mov [mmach3d+2], eax
	mov [mmach7d+2], eax
	mov eax, [_asm2]
	mov [mmach4d+2], eax
	mov [mmach8d+2], eax
	pop ebp;
	jmp short mhlineskipmodify_

ALIGN 16
mhlineskipmodify_:

	push ebp

	xor eax, eax
	mov ebp, ebx

	test ecx, 00010000h
	jnz short mbeghline

msh1d: shr ebx, 26
msh2d: shld ebx, esi, 6
	add ebp, [_asm1]
mmach9d: mov al, [ebx+88888888h]    ;picoffs
	add esi, [_asm2]
	cmp al, 255
	je mskip5

	mmach10d: mov cl, [eax+88888888h]    ;shadeoffs
	mov [edi], cl
mskip5:
	inc edi
	sub ecx, 65536
	jc near mendhline
	jmp short mbeghline

ALIGN 16
mpreprebeghline:                                            ;1st only
	mov al, cl
mmach2d: mov al, [eax+88888888h]    ;shadeoffs
	mov [edi], al

mprebeghline:
	add edi, 2
	sub ecx, 131072
	jc near mendhline
mbeghline:
mmach3d: lea ebx, [ebp+88888888h]            ;bxinc
msh3d: shr ebp, 26
msh4d: shld ebp, esi, 6
mmach4d: add esi, 88888888h                  ;byinc
mmach1d: mov cl, [ebp+88888888h]    ;picoffs
mmach7d: lea ebp, [ebx+88888888h]            ;bxinc

msh5d: shr ebx, 26
msh6d: shld ebx, esi, 6
mmach8d: add esi, 88888888h                  ;byinc
mmach5d: mov ch, [ebx+88888888h]    ;picoffs

	cmp cl, 255
	je short mskip1
	cmp ch, 255
	je short mpreprebeghline

	mov al, cl                                                  ;BOTH
mmach2da: mov bl, [eax+88888888h]    ;shadeoffs
	mov al, ch
mmach2db: mov bh, [eax+88888888h]    ;shadeoffs
	mov [edi], bx
	add edi, 2
	sub ecx, 131072
	jnc short mbeghline
	jmp mendhline
mskip1:                                                     ;2nd only
	cmp ch, 255
	je short mprebeghline

	mov al, ch
mmach6d: mov al, [eax+88888888h]    ;shadeoffs
	mov [edi+1], al
	add edi, 2
	sub ecx, 131072
	jnc short mbeghline
mendhline:

	pop ebp
	ret

_hlineasm4:
	push ebp;
	mov ebp, esp;
	add ebp, 28;
	mov eax, [ebp - 20];
	mov ebx, [ebp - 16];
	mov ecx, [ebp - 12];
	mov edx, [ebp - 8];
	mov esi, [ebp - 4];
	mov edi, [ebp - 0];
	lea ebp, [eax + 1];
	cmp ebp, 8;
	jle near shorthline;
	test edi, 1;
	jnz skipthe1byte;
	mov eax, esi;
hxsiz1:
	shr eax, 26;
hysiz1:
	shld eax, edx, 6;
hoffs1:
	mov cl, [eax + 0x88888888];
pal1:
	mov bl, [ecx + 0x88888888];
	sub esi, [_asm1];
	sub edx, [_asm2];
	mov [edi], bl;
	dec edi;
	dec ebp;
skipthe1byte:
	test edi, 2;
	jnz skipthe2byte;
	mov eax, esi;
hxsiz2: 
	shr eax, 26;
hysiz2: 
	shld eax, edx, 6;
hoffs2: 
	mov cl, [eax + 88888888h];
pal2: 
	mov bh, [ecx + 88888888h];
	sub esi, [_asm1];
	sub edx, [_asm2];
	mov eax, esi;
hxsiz3: 
	shr eax, 26;
hysiz3: 
	shld eax, edx, 6;
hoffs3: 
	mov cl, [eax + 88888888h];
pal3: 
	mov bl, [ecx + 88888888h];
	sub esi, [_asm1];
	sub edx, [_asm2];
	mov [edi - 1], bx;
	sub edi, 2;
	sub ebp, 2;
skipthe2byte:
	mov eax, esi;
machxbits1: 
	shl esi, 6                     ;xbits
machnegxbits1: 
	shr eax, 32-6               ;32-xbits
	mov dl, al
	inc edi
	add ebx, ebx
	mov eax, edx
	jc beginhline64
	mov eax, [_asm1]
machxbits2: rol eax, 6                     ;xbits
	mov [hmach4a+2], eax
	mov [hmach4b+2], eax
	mov [hmach4c+2], eax
	mov [hmach4d+2], eax
	mov ebx, eax
	mov eax, [_asm2]
	mov al, bl
	mov [hmach1a+2], eax
	mov [hmach1b+2], eax
	mov [hmach1c+2], eax
	mov [hmach1d+2], eax
	mov eax, edx
	jmp beginhline64
ALIGN 16
prebeginhline64:
	mov [edi], ebx
beginhline64:
hmach3a: 
	rol eax, 6
hmach2a: 
	and eax, 00008888h
hmach4a: 
	sub esi, 88888888h
hmach1a: 
	sbb edx, 88888888h
	sub edi, 4
hoffs4: 
	mov cl, [eax + 88888888h]
	mov eax, edx
hmach3b: 
	rol eax, 6
hmach2b:
	and eax, 00008888h
hmach4b: 
	sub esi, 88888888h
hmach1b: 
	sbb edx, 88888888h
pal4: 
	mov bh, [ecx + 88888888h]
hoffs5: 
	mov cl, [eax + 88888888h]
	mov eax, edx
hmach3c: 
	rol eax, 6
pal5: 
	mov bl, [ecx + 88888888h]
hmach2c: 
	and eax, 00008888h
	shl ebx, 16
hmach4c: 
	sub esi, 88888888h
hmach1c: 
	sbb edx, 88888888h
hoffs6: 
	mov cl, [eax + 88888888h]
	mov eax, edx
hmach3d: 
	rol eax, 6
hmach2d: 
	and eax, 00008888h
hmach4d:
	sub esi, 88888888h
hmach1d:
	sbb edx, 88888888h
pal6: 
	mov bh, [ecx + 88888888h]
hoffs7: 
	mov cl, [eax + 88888888h]
	mov eax, edx
	sub ebp, 4
	nop
pal7: 
	mov bl, [ecx + 88888888h]
	jnc near prebeginhline64
skipthe4byte:
	test ebp, 2
	jz skipdrawthe2
	rol ebx, 16
	mov [edi+2], bx
	sub edi, 2
skipdrawthe2:
	test ebp, 1
	jz skipdrawthe1
	shr ebx, 24
	mov [edi+3], bl
skipdrawthe1:
	pop ebp
	ret
shorthline:
	test ebp, ebp
	jz endshorthline
begshorthline:
	mov eax, esi
hxsiz4: 
	shr eax, 26
hysiz4:
	shld eax, edx, 6
hoffs8:
	mov cl, [eax + 88888888h]
pal8:
	mov bl, [ecx + 88888888h]
	sub esi, [_asm1]
	sub edx, [_asm2]
	mov [edi], bl
	dec edi
	dec ebp
	jnz begshorthline
endshorthline:
	pop ebp
	ret

_setuphlineasm4:
	push ebp;
	mov ebp, esp;
	add ebp, 12;
	mov eax, [ebp - 4];
	mov ebx, [ebp - 0];
machxbits3: 
	rol eax, 6                     ;xbits
	mov [hmach4a+2], eax
	mov [hmach4b+2], eax
	mov bl, al
	mov [hmach4c+2], eax
	mov [hmach4d+2], eax
	mov [hmach1a+2], ebx
	mov [hmach1b+2], ebx
	mov [hmach1c+2], ebx
	mov [hmach1d+2], ebx
	pop ebp;
	ret;

ALIGN 16
_setvlinebpl:
	push ebp;
	mov ebp, esp;
	add ebp, 8;
	mov eax, [ebp - 0];
	mov [fixchain1a+2], eax
	mov [fixchain1b+2], eax
	;mov [fixchain1m+2], eax
	;mov [fixchain1t+2], eax
	;mov [fixchain1s+2], eax
	;mov [mfixchain1s+2], eax
	;mov [tfixchain1s+2], eax
	mov [fixchain2a+2], eax
	;mov [profixchain2a+2], eax
	;mov [fixchain2ma+2], eax
	;mov [fixchain2mb+2], eax
	;mov [fixchaint2a+1], eax
	;mov [fixchaint2b+2], eax
	;mov [fixchaint2c+2], eax
	;mov [fixchaint2d+2], eax
	;mov [fixchaint2e+2], eax
	pop ebp
	ret

_sethlinesizes:
	push ebp;
	mov ebp, esp;
	add ebp, 16;
	mov eax, [ebp - 8];
	mov ebx, [ebp - 4];
	mov ecx, [ebp - 0];
	mov [machxbits1+2], al
	mov [machxbits2+2], al
	mov [machxbits3+2], al
	neg al
	mov [hxsiz1+2], al
	mov [hxsiz2+2], al
	mov [hxsiz3+2], al
	mov [hxsiz4+2], al
	mov [machnegxbits1+2], al

	mov [hysiz1+3], bl
	mov [hysiz2+3], bl
	mov [hysiz3+3], bl
	mov [hysiz4+3], bl
	mov [hmach3a+2], bl
	mov [hmach3b+2], bl
	mov [hmach3c+2], bl
	mov [hmach3d+2], bl

	mov [hoffs1+2], ecx
	mov [hoffs2+2], ecx
	mov [hoffs3+2], ecx
	mov [hoffs4+2], ecx
	mov [hoffs5+2], ecx
	mov [hoffs6+2], ecx
	mov [hoffs7+2], ecx
	mov [hoffs8+2], ecx

	mov edx, -1
	mov cl, al
	sub cl, bl
	shr edx, cl
	mov [hmach2a+1], edx
	mov [hmach2b+1], edx
	mov [hmach2c+1], edx
	mov [hmach2d+1], edx
	pop ebp;
	ret;

_setpalookupaddress:
	push ebp;
	mov ebp, esp;
	add ebp, 8;
	mov eax, [ebp - 0];
	mov [pal1+2], eax
	mov [pal2+2], eax
	mov [pal3+2], eax
	mov [pal4+2], eax
	mov [pal5+2], eax
	mov [pal6+2], eax
	mov [pal7+2], eax
	mov [pal8+2], eax
	pop ebp;
	ret

_detectmmx:
	pushfd
	pop eax;
	mov ebx, eax;
	xor eax, 00200000h;
	push eax;
	popfd;
	pushfd;
	pop eax;
	cmp eax, ebx;
	je notmmx;
	mov eax, 1;
	cpuid
	and edx, 0x1000000;
	jz notmmx;
	mov eax, 1;
	ret;
notmmx;
	xor eax, eax;
	ret