// ModTC.cpp : implementation file
//

#include "stdafx.h"
#include "glDuke.h"
#include "ModTC.h"
#include <DIRECT.H>
#include "Settings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettings set;

/////////////////////////////////////////////////////////////////////////////
// CModTC dialog


CModTC::CModTC(CWnd* pParent /*=NULL*/)
	: CDialog(CModTC::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModTC)
	//}}AFX_DATA_INIT
}


void CModTC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModTC)
	DDX_Control(pDX, IDC_MODS, m_List);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModTC, CDialog)
	//{{AFX_MSG_MAP(CModTC)
	ON_BN_CLICKED(IDC_SETMOD, OnSetmod)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CModTC message handlers

DUKENUKEMMOD	Mods[32];
char			strPath[32][128];

void CModTC::LookForMods(char *lpstrDir)
{
	WIN32_FIND_DATA res;
	HANDLE next;
	FILE *stream;
	DUKENUKEMMOD m;
	char strLastDir[256];
	char strCompleteDir[256];
	getcwd(strLastDir, 256);
	if(lpstrDir != NULL)
	{
		chdir(lpstrDir);
	}
	next = FindFirstFile("*", &res);
	while(1)
	{
		if(next == INVALID_HANDLE_VALUE)
		{
			break;
		}
		if(res.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
		{
			if(strcmp(res.cFileName, ".") && strcmp(res.cFileName, ".."))
			{
				strcpy(strCompleteDir, strLastDir);
				strcat(strCompleteDir, "\\");
				strcat(strCompleteDir, res.cFileName);
				LookForMods(strCompleteDir);
			}
		}
		if(!FindNextFile(next, &res))
		{
			break;
		}
	}
	next = FindFirstFile("*.dnm", &res);
	while(1)
	{
		if(next == INVALID_HANDLE_VALUE)
		{
			break;
		}
		stream = fopen(res.cFileName, "rb");
		fread(&m, sizeof(DUKENUKEMMOD), 1, stream);
		fclose(stream);
		m_List.InsertItem(m_List.GetItemCount(), m.strTitle);
		m_List.SetItemText(m_List.GetItemCount() - 1, 1, m.strDescription);
		memcpy(&Mods[m_List.GetItemCount() - 2], &m, sizeof(DUKENUKEMMOD));
		strcpy(strPath[m_List.GetItemCount() - 2], lpstrDir);
		strcat(strPath[m_List.GetItemCount() - 2], "\\");
		strcat(strPath[m_List.GetItemCount() - 2], res.cFileName);
		if(!FindNextFile(next, &res))
		{
			break;
		}
	}
	chdir(strLastDir);
}

void CModTC::UpdateCurrent()
{
	if(!strcmp(set.m_Setup.lpstrModPath, "(NORMAL DUKE)"))
	{
		SetDlgItemText(IDC_MOD, "Duke Nukem 3D");
	}
	else
	{
		DUKENUKEMMOD m;
		FILE *stream;
		stream = fopen(set.m_Setup.lpstrModPath, "rb");
		fread(&m, sizeof(DUKENUKEMMOD), 1, stream);
		fclose(stream);
		SetDlgItemText(IDC_MOD, m.strTitle);
	}
}

BOOL CModTC::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	RECT rc;
	m_List.GetClientRect(&rc);
	m_List.InsertColumn(0, "Game Name");
	m_List.SetColumnWidth(0, (rc.right / 3) + 30);
	m_List.InsertColumn(1, "Description");
	m_List.SetColumnWidth(1, rc.right);
	//Insert the standard Duke Nukem 3D
	m_List.InsertItem(0, "Duke Nukem 3D");
	m_List.SetItemText(0, 1, "The usual Duke Nukem 3D. Kick some alien asses.");
	LookForMods(NULL);
	m_List.SetSelectionMark(0);
	UpdateCurrent();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CModTC::OnSetmod() 
{
	// TODO: Add your control notification handler code here
	int nNumber;
	nNumber = m_List.GetSelectionMark();
	if(nNumber == -1)
	{
		return;
	}
	if(nNumber == 0)
	{
		strcpy(set.m_Setup.lpstrModPath, "(NORMAL DUKE)");
	}
	else
	{
		strcpy(set.m_Setup.lpstrModPath, strPath[nNumber - 1]);
	}
	DeleteFile("CONDATA.DAT");
	UpdateCurrent();
}
