// MusicOpt.cpp : implementation file
//

#include "stdafx.h"
#include "glDuke.h"
#include "MusicOpt.h"
#include "Settings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CSettings set;

/////////////////////////////////////////////////////////////////////////////
// CMusicOpt dialog


CMusicOpt::CMusicOpt(CWnd* pParent /*=NULL*/)
	: CDialog(CMusicOpt::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMusicOpt)
	m_MusicDriver = -1;
	//}}AFX_DATA_INIT
}


void CMusicOpt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMusicOpt)
	DDX_CBIndex(pDX, IDC_MUSICDRIVER, m_MusicDriver);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMusicOpt, CDialog)
	//{{AFX_MSG_MAP(CMusicOpt)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMusicOpt message handlers

BOOL CMusicOpt::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CWnd *wnd;
	wnd = GetDlgItem(IDC_MUSICDRIVER);
	wnd->SendMessage(CB_ADDSTRING, 0, (LPARAM)"MCI (Multimedia Command Interface)");
	wnd->SendMessage(CB_ADDSTRING, 0, (LPARAM)"DirectMusic (requires DirectX7)");
	wnd->SendMessage(CB_ADDSTRING, 0, (LPARAM)"CD Audio");
	wnd->SendMessage(CB_SETCURSEL, set.m_Setup.nMusicDriver, 0);
	wnd->Detach();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMusicOpt::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	set.m_Setup.nMusicDriver = (unsigned _int8)GetDlgItem(IDC_MUSICDRIVER)->SendMessage(CB_GETCURSEL, 0, 0);	
}
