// Settings.h: interface for the CSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGS_H__6274A741_2D0B_11D5_AEF3_0048548C5440__INCLUDED_)
#define AFX_SETTINGS_H__6274A741_2D0B_11D5_AEF3_0048548C5440__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define STATUS_BASE_UI_COUNT		5
#define STATUS_BASE_HL_COUNT		STATUS_BASE_UI_COUNT

#define STATUS_BASE_ELEMENT_COUNT	STATUS_BASE_HL_COUNT + 4

struct SETUP
{
	char			lpstrRenderer[256];
	int				nControls[52];
	unsigned _int8	dwControlStatus;
	unsigned _int8	nMusicDriver;
	unsigned _int8	nSoundEnabled;
	unsigned _int8	nMusicEnabled;
	char			lpstrModPath[256];
	int				nMouseControls[3];
	GUID			JoystickGUID;
};

class CSettings  
{
public:
			CSettings();
	virtual ~CSettings();
	void	Save();
	int m_nCreated;
	SETUP m_Setup;
};

#endif // !defined(AFX_SETTINGS_H__6274A741_2D0B_11D5_AEF3_0048548C5440__INCLUDED_)
