#include "COMMON.H"
#include "ANIMATE.H"

//Functions definitions
#define VM_ADDHEALTH	0xB000
#define VM_GETHEALTH	0xB001
#define VM_GLOBALSOUND	0xB002
#define VM_QUOTE		0xB003
#define VM_GETDISTANCE	0xB004
#define VM_CANSEE		0xB005
#define VM_ADDAMMO		0xB006

XBUILD_CONSCRIPTACTOR_CONTEXT*		pContext;
unsigned short						wParam1;
unsigned short						wParam2;
unsigned short						wParam3;
int									(*CONVM_FunctionCallback)(int, int, XBUILD_MAP_SPRITE*) = NULL;

void CONVM_ILL() { }
void CONVM_00() { /*NOP*/ }
void CONVM_01() { pContext->wPC += 2; if(pContext->wTrue == pContext->wConditions) { pContext->wPC = wParam1 - 1; } pContext->wConditions = 0; pContext->wTrue = 0; }
void CONVM_02() { pContext->wPC += 2; if((pContext->wTrue != pContext->wConditions) || pContext->wConditions == 0) { pContext->wPC = wParam1 - 1; } pContext->wConditions = 0; pContext->wTrue = 0; }
void CONVM_03() { pContext->wPC += 2; pContext->wPC = wParam1 - 1; }
void CONVM_04()	{ pContext->wPC = 0xFFFE; }
void CONVM_10() { pContext->wPC += 4; /* ADD SOME STUFF IN THE INV*/ }
void CONVM_11() { pContext->wPC += 2; CONVM_FunctionCallback(VM_ADDHEALTH, wParam1, pContext->pSprite); }
void CONVM_13() { pContext->wPC += 2; CONVM_FunctionCallback(VM_QUOTE, wParam1, NULL); }
void CONVM_15() { pContext->wPC += 6; }
void CONVM_16() { pContext->wHP = 0xFFFF; }
void CONVM_17() { pContext->wPC += 4; /*ADD SOME AMMO */ }
void CONVM_18() { pContext->wPC += 2; /*ACTION*/ }
void CONVM_1A() { pContext->wPC += 4; /*SPAWN SOME DEBRIS*/ }
void CONVM_1D() { pContext->wPC += 2; CONVM_FunctionCallback(VM_GLOBALSOUND, wParam1, NULL); }
void CONVM_1E() { pContext->wPC += 4; CONVM_FunctionCallback(VM_ADDAMMO, wParam1 | (wParam2 << 16), NULL); }
void CONVM_32() { pContext->wPC += 2; pContext->wConditions++; if(rand() & wParam1) { pContext->wTrue++; } } 
void CONVM_33() { pContext->wPC += 2; pContext->wConditions++; if(pContext->wPlayerStatus & wParam1) { pContext->wTrue++; } }
void CONVM_34() { pContext->wPC += 2; pContext->wConditions++; if(pContext->wCount >= wParam1) { pContext->wTrue++; } }
void CONVM_35() { pContext->wPC += 2; pContext->wConditions++; if(CONVM_FunctionCallback(VM_GETDISTANCE, NULL, pContext->pSprite) < wParam1) { pContext->wTrue++; } }
void CONVM_36() { pContext->wPC += 4; pContext->wConditions++; pContext->wTrue++; }
void CONVM_37() { pContext->wPC += 2; pContext->wConditions++; if(pContext->wSpawnedBy == wParam1) { pContext->wTrue++; } }
void CONVM_38() { pContext->wPC += 2; pContext->wConditions++; if(CONVM_FunctionCallback(VM_GETHEALTH, NULL, pContext->pSprite) < wParam1) { pContext->wTrue++; } }
void CONVM_39() { pContext->wPC += 2; pContext->wConditions++; if(pContext->wMove == wParam1) { pContext->wTrue++; } }
void CONVM_3A() { pContext->wConditions++; if(pContext->bHitByWeapon) { pContext->wTrue++; } pContext->bHitByWeapon = 0; }
void CONVM_3B() { pContext->wConditions++; if(pContext->wHP <= 0) { pContext->wTrue++; } }
void CONVM_3C() { pContext->wPC += 2; pContext->wConditions++; if(pContext->pSprite->Pic == wParam1) { pContext->wTrue++; } }
void CONVM_3D() { pContext->wConditions++; if(CONVM_FunctionCallback(VM_CANSEE, NULL, pContext->pSprite)) { pContext->wTrue++; } }

static void (*CONVM_Instructions[0x40])(void) =
{
	CONVM_00,	CONVM_01,	CONVM_02,	CONVM_03,	CONVM_04,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,
	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,
	CONVM_10,	CONVM_11,	CONVM_ILL,	CONVM_13,	CONVM_ILL,	CONVM_15,	CONVM_16,	CONVM_17,
	CONVM_18,	CONVM_ILL,	CONVM_1A,	CONVM_ILL,	CONVM_ILL,	CONVM_1D,	CONVM_1E,	CONVM_ILL,
	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,
	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,	CONVM_ILL,
	CONVM_ILL,	CONVM_ILL,	CONVM_32,	CONVM_33,	CONVM_34,	CONVM_35,	CONVM_36,	CONVM_37,
	CONVM_38,	CONVM_39,	CONVM_3A,	CONVM_3B,	CONVM_3C,	CONVM_3D,	CONVM_ILL,	CONVM_ILL,
};

extern "C" void DLLEXPORT XBUILD_CONVM_Execute(XBUILD_CONSCRIPTACTOR_CONTEXT *pC)
{
	unsigned char nOpcode;
	pContext = pC;
	pC->wPC = 0;
	while(pContext->wPC != 0xFFFF)
	{
		nOpcode = pContext->pCode[pContext->wPC];
		wParam1 = (pContext->pCode[(pContext->wPC) + 1] << 8) | (pContext->pCode[(pContext->wPC) + 2]);
		wParam2 = (pContext->pCode[(pContext->wPC) + 3] << 8) | (pContext->pCode[(pContext->wPC) + 4]);
		wParam3 = (pContext->pCode[(pContext->wPC) + 5] << 8) | (pContext->pCode[(pContext->wPC) + 6]);
		CONVM_Instructions[nOpcode]();
		pContext->wPC++;
	}
	pC->wCount++;
}

extern "C" void DLLEXPORT XBUILD_CONVM_SetFunctionCallback(void *pCallback)
{
	CONVM_FunctionCallback = (int(*)(int, int, XBUILD_MAP_SPRITE*))pCallback;
}

extern "C" void DLLEXPORT XBUILD_CONVM_Disassemble(char *pOutput, unsigned char *pInput, unsigned short wStart, unsigned short wEnd)
{
	unsigned _int8 bOpcode;
	char strTemp[256];
	strcpy(pOutput, "");
	while(wStart < wEnd)
	{
		bOpcode = pInput[wStart];
		wParam1 = (pInput[(wStart) + 1] << 8) | (pInput[(wStart) + 2]);
		wParam2 = (pInput[(wStart) + 3] << 8) | (pInput[(wStart) + 4]);
		wParam3 = (pInput[(wStart) + 5] << 8) | (pInput[(wStart) + 6]);
		sprintf(strTemp, "$%0.4X\t", wStart);
		strcat(pOutput, strTemp);
		switch(bOpcode)
		{
		case 0x00:
			sprintf(strTemp, "NOP");
			break;
		case 0x01:
			sprintf(strTemp, "JTR $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x02:
			sprintf(strTemp, "JFS $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x03:
			sprintf(strTemp, "JMP $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x04:
			sprintf(strTemp, "END");
			break;
		case 0x10:
			sprintf(strTemp, "ADDINVENTORY $%0.4X, $%0.4X", wParam1, wParam2);
			wStart += 4;
			break;
		case 0x11:
			sprintf(strTemp, "ADDPHEALTHL $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x13:
			sprintf(strTemp, "QUOTE $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x15:
			sprintf(strTemp, "PALFROM $%0.4X, $%0.4X, $%0.4X", wParam1, wParam2, wParam3);
			wStart += 6;
			break;
		case 0x16:
			sprintf(strTemp, "KILLIT");
			break;
		case 0x17:
			sprintf(strTemp, "ADDWEAPON $%0.4X, $%0.4X", wParam1, wParam2);
			wStart += 4;
			break;
		case 0x1D:
			sprintf(strTemp, "GLOBALSOUND $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x1E:
			sprintf(strTemp, "ADDAMMO $%0.4X, $%0.4X", wParam1, wParam2);
			wStart += 4;
			break;
		case 0x32:
			sprintf(strTemp, "IFRND $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x33:
			sprintf(strTemp, "IFP $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x34:
			sprintf(strTemp, "IFCOUNT $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x35:
			sprintf(strTemp, "IFPDISTL $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x36:
			sprintf(strTemp, "IFPINVENTORY $%0.4X, $%0.4X", wParam1, wParam2);
			wStart += 4;
			break;
		case 0x37:
			sprintf(strTemp, "IFSPAWNEDBY $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x38:
			sprintf(strTemp, "IFPHEALTHL $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x39:
			sprintf(strTemp, "IFMOVE $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x3C:
			sprintf(strTemp, "IFACTOR $%0.4X", wParam1);
			wStart += 2;
			break;
		case 0x3D:
			sprintf(strTemp, "IFCANSEETARGET");
			break;
		default:
			sprintf(strTemp, "ILLEGAL $%0.2X", bOpcode);
			break;
		}
		strcat(pOutput, strTemp);
		strcat(pOutput, "\r\n");
		wStart++;
	}
}