__inline int sqr(int a)
{
	__asm
	{
		mov eax, dword ptr[a];
		imul eax, eax;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline void swapshort(int *a, int *b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov cx, [eax];
		mov dx, [ebx];
		mov [ebx], cx;
		mov [eax], dx;
		mov dword ptr[a], eax;
		mov dword ptr[b], ebx;
	}
}

__inline int scale(int a, int b, int c)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov ecx, dword ptr[c];
		imul edx;
		idiv ecx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int klabs(int a)
{
	__asm
	{
		mov eax, dword ptr[a];
		test eax, eax;
		jns skipnegate;
		neg eax;
skipnegate:
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale(int a, int b, int c)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov ecx, dword ptr[c];
		imul edx;
		shrd eax, edx, cl;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale1(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 1;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale2(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 2;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale4(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 4;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale5(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 5;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale8(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 8;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale10(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 10;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale11(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 11;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale12(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 12;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale14(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 14;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale15(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 15;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale16(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 16;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale18(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 18;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale19(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 19;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale20(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 20;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale21(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 21;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale23(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 23;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale30(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		shrd eax, edx, 30;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int mulscale32(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		imul edx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale2(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 2;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale3(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 3;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale6(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 6;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale10(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 10;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale14(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 14;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale16(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 16;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale24(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 24;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale28(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		shrd eax, edx, 28;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int dmulscale32(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov edx, dword ptr[b];
		mov esi, dword ptr[c];
		mov edi, dword ptr[d];
		imul edx;
		mov ebx, eax;
		mov eax, esi;
		mov esi, edx;
		imul edi;
		add eax, ebx;
		adc edx, esi;
		mov dword ptr[a], edx;
	}
	return a;
}

__inline int divscale12(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 20;
		shl eax, 12;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale14(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 18;
		shl eax, 14;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale16(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 16;
		shl eax, 16;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale26(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 6;
		shl eax, 26;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale28(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 4;
		shl eax, 28;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale30(int a, int b)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ebx, dword ptr[b];
		mov edx, eax;
		sar edx, 2;
		shl eax, 30;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline int divscale32(int a, int b)
{
	__asm
	{
		mov edx, dword ptr[a];
		mov ebx, dword ptr[b];
		xor eax, eax;
		idiv ebx;
		mov dword ptr[a], eax;
	}
	return a;
}

__inline void qinterpolatedown16short(int a, int b, int c, int d)
{
	__asm
	{
		mov eax, dword ptr[a];
		mov ecx, dword ptr[b];
		mov edx, dword ptr[c];
		mov esi, dword ptr[d];
		mov ebx, ecx;
		shr ecx, 1;
		jz skipbegcalc;
begqcalc:
		lea edi, [edx + esi];
		sar edx, 16;
		mov dword ptr[eax], edx;
		lea edx, [edi + esi];
		sar edi, 16;
		mov dword ptr[eax + 4], edi;
		add eax, 8;
		dec ecx;
		jnz begqcalc;
		test ebx, 1;
		jz skipbegqcalc2;
skipbegcalc:
		sar edx, 16;
		mov dword ptr[eax], edx;
skipbegqcalc2:
	}
}
