// glDukeDlg.h : header file
//

#if !defined(AFX_GLDUKEDLG_H__8DF3D8C6_2C7D_11D5_AEF3_0048548C5440__INCLUDED_)
#define AFX_GLDUKEDLG_H__8DF3D8C6_2C7D_11D5_AEF3_0048548C5440__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SETTINGS.H"

struct TItem
{
	int nID;
	const char *strName;
	int nDialog;
	void *Handle;
	void *Parent;
	CDialog *dialog;
	BOOL Created;
	long HelpID;
};

/////////////////////////////////////////////////////////////////////////////
// CGlDukeDlg dialog

class CGlDukeDlg : public CDialog
{
// Construction
public:
	CGlDukeDlg(CWnd* pParent = NULL);	// standard constructor
	CString m_Level;
	int nCanceled;
// Dialog Data
	//{{AFX_DATA(CGlDukeDlg)
	enum { IDD = IDD_GLDUKE_DIALOG };
	CTreeCtrl	m_Tree;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGlDukeDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	void InsertItem(HTREEITEM, TItem*, BOOL);
	CDialog *GetCorrectClass(int);
	// Generated message map functions
	//{{AFX_MSG(CGlDukeDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	afx_msg void OnSelchangedTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClose();
	afx_msg void OnQuit();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GLDUKEDLG_H__8DF3D8C6_2C7D_11D5_AEF3_0048548C5440__INCLUDED_)
