#define DLLEXPORT __declspec(dllexport)

#define TITLE "xBUILD"

#define MAXSECTORS 1024
#define MAXWALLS 8192
#define MAXSPRITES 4096

#define MAXTILES 9216
#define MAXSTATUS 1024
#define MAXPLAYERS 16
#define MAXXDIM 1600
#define MAXYDIM 1200
#define MAXPALOOKUPS 256
#define MAXPSKYTILES 256
#define MAXSPRITESONSCREEN 1024

#define CLIPMASK0 (((1L)<<16)+1L)
#define CLIPMASK1 (((256L)<<16)+64L)

#include <WINDOWS.H>
#include <STDIO.H>
#include <MMSYSTEM.H>
#include <DMUSICI.H>
#include <DMUSICC.H>
#include <DIRECT.H>
#include <DSOUND.H>
#include <MATH.H>
#include "INCREMENTATOR.H"
#include "RESOURCE.H"
#include "CONSOLE.H"
#include "GRPMANAGER.H"
#include "RTSMANAGER.H"
#include "CONSCRIPT.H"
#include "XBUILDREN.H"
#include "ART.H"
#include "MAP.H"
#include "MUSIC.H"
#include "SOUND.H"
#include "CONACTORCOMPILER.H"

void msgboxf(HWND, char*, int, const char*, ...);

extern HANDLE	XBUILD_hMod;

#define GETWORD(pointer, addr) pointer[addr] | (pointer[addr + 1] << 8)
#define GETLONG(pointer, addr) pointer[addr] | (pointer[addr + 1] << 8) | (pointer[addr + 2] << 16) | (pointer[addr + 3] << 24)
